package hay.app;

import hay.component.HayAnniversary;
import hay.component.HayAnniversaryAdapter;
import hay.database.HayDatabase;
import java.util.ArrayList;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.ContentValues;
import android.content.DialogInterface;
import android.database.Cursor;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

public class HayModify extends Activity {

	private ArrayList<Date> anni_List;

	private Date birthday;
	private int lunar = 0;
	private LinearLayout anni_layout;

	private int contact_id ;

	private Button button_anniversary;
	private Button button_save;
	private Button button_cancel;

	private EditText edittext_twitter;
	private EditText edittext_me2day;

	private View datepickerView;

	private HayDatabase db = new HayDatabase(this);

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.modify);

		getWindow().setTitle("ó ");
		
		button_anniversary = (Button)findViewById(R.modify.button_anniversary_add);
		button_save = (Button)findViewById(R.modify.button_save);
		button_cancel = (Button)findViewById(R.modify.button_cancel);
		edittext_twitter = (EditText)findViewById(R.modify.EditText_Twitter);
		edittext_me2day = (EditText)findViewById(R.modify.EditText_Me2day);

		anni_layout = (LinearLayout)findViewById(R.modify.anni_layout);

		anni_List = new ArrayList<Date>();

		// contact_id ´. ( ÿ   rawcontact ´. 츮 ÿ   contact ´.)
		Uri uri = getIntent().getData();
		String noid_uri = uri.toString().substring(0, 39);

		if( !noid_uri.equals(ContactsContract.Contacts.CONTENT_URI.toString()) ){

			//contact_id ã
			Cursor cursor = getContentResolver().query(uri, null, null, null, null);
			if(cursor.moveToNext()){
				contact_id = cursor.getInt(cursor.getColumnIndex(ContactsContract.RawContacts.CONTACT_ID));
			}
		}
		else{
			String temp = uri.toString().replace(ContactsContract.Contacts.CONTENT_URI.toString()+"/", "");
			contact_id = Integer.parseInt(temp);
		}

		//ȭ Ѵ.
		init();

		//ư 
		button_save.setOnClickListener(
				new View.OnClickListener() {
					public void onClick(View v) {
						save();
						finish();
					}
				}
		);

		button_cancel.setOnClickListener(
				new View.OnClickListener() {
					public void onClick(View v) {
						finish();
					}
				}
		);

		//		button_birthday.setOnClickListener(
		//				new View.OnClickListener() {
		//					public void onClick(View v) {
		//
		//						LayoutInflater factory = LayoutInflater.from(HayModify.this);
		//						final View datepickerView = factory.inflate(R.layout.datepicker_birthday, null);
		//
		//						new AlertDialog.Builder(HayModify.this)
		//						.setIcon(R.drawable.icon)
		//						.setTitle(" ¥ ")
		//						.setView(datepickerView)
		//						.setPositiveButton("", new DialogInterface.OnClickListener() {
		//							public void onClick(DialogInterface dialog, int whichButton) {
		//
		//								//¥ ͼ Ƶд.
		//								DatePicker dp = (DatePicker)datepickerView.findViewById(R.datepicker_birthday.DatePicker);
		//								CheckBox cb = (CheckBox)datepickerView.findViewById(R.datepicker_birthday.CheckBox);
		//
		//								Date date = new Date();
		//								date.setYear( ""+dp.getYear() );
		//								if( dp.getMonth()+1 < 10 ) date.setMonth( "0"+(dp.getMonth()+1) );
		//								else date.setMonth( ""+(dp.getMonth()+1) );
		//								if( dp.getDayOfMonth() < 10 ) date.setDay( "0"+dp.getDayOfMonth() );
		//								else date.setDay( ""+dp.getDayOfMonth() );
		//
		//								if(cb.isChecked()) lunar = 1;
		//								else lunar = 0;
		//
		//								birthday = date;
		//								button_birthday.setText(date.getYear()+" "+date.getMonth()+" "+date.getDay()+"");
		//							}
		//						})
		//						.setNegativeButton("", new DialogInterface.OnClickListener() {
		//							public void onClick(DialogInterface dialog, int whichButton) {
		//								button_birthday.setText("");
		//							}
		//						})
		//						.create().show();
		//					}
		//				}
		//		);

		button_anniversary.setOnClickListener(
				new View.OnClickListener() {
					public void onClick(View v) {

						LayoutInflater factory = LayoutInflater.from(HayModify.this);
						datepickerView = factory.inflate(R.layout.datepicker_annivarsary, null);

						final RadioGroup rg = (RadioGroup)datepickerView.findViewById(R.datepicker_anniversary.RadioGroup);
						final RadioButton rb = (RadioButton)datepickerView.findViewById(R.datepicker_anniversary.RadioButton);
						final RadioButton rb2 = (RadioButton)datepickerView.findViewById(R.datepicker_anniversary.RadioButton2);
						final DatePicker dp = (DatePicker)datepickerView.findViewById(R.datepicker_anniversary.DatePicker);
						final EditText et = (EditText)datepickerView.findViewById(R.datepicker_anniversary.EditText);
						final CheckBox cb = (CheckBox)datepickerView.findViewById(R.datepicker_anniversary.CheckBox);
						
						rg.setOnCheckedChangeListener(
								new RadioGroup.OnCheckedChangeListener() {
									public void onCheckedChanged(RadioGroup group, int checkedId) {
										if(rb.getId()==checkedId){
											et.setEnabled(false);
										}
										else if(rb2.getId()==checkedId){
											et.setEnabled(true);
										}
									}
								}
						);

						new AlertDialog.Builder(HayModify.this)
						.setIcon(R.drawable.icon)
						.setTitle(" ߰")
						.setView(datepickerView)
						.setPositiveButton("߰ϱ", new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int whichButton) {
								Date date = new Date();
								date.setYear( ""+dp.getYear() );
								if( dp.getMonth()+1 < 10 ) date.setMonth( "0"+(dp.getMonth()+1) );
								else date.setMonth( ""+(dp.getMonth()+1) );
								if( dp.getDayOfMonth() < 10 ) date.setDay( "0"+dp.getDayOfMonth() );
								else date.setDay( ""+dp.getDayOfMonth() );

								
								date.setName( rb.isChecked()?"":"" );
								
								boolean lunar = cb.isChecked();
								
								TextView text = new TextView(HayModify.this);
								text.setId(anni_List.size());
								text.setText( "["+date.getName()+" "+et.getText().toString()+"] "+(lunar?" ":" ")+ date.getYear()+" "+date.getMonth()+" "+date.getDay()+"");
								text.setTextColor(Color.BLACK);
								text.setTextSize(14);
								text.setPadding(10,5,0,5);
								text.setOnClickListener(
										new View.OnClickListener() {
											public void onClick(final View v) {
												new AlertDialog.Builder(HayModify.this)
												.setTitle("Ͻðڽϱ?")
												.setMessage(((TextView)v).getText())
												.setIcon(R.drawable.icon)
												.setPositiveButton("",
														new DialogInterface.OnClickListener() {
													public void onClick(DialogInterface dialog, int which) {
														//Ŭÿ 
														getContentResolver().delete(
																ContactsContract.Data.CONTENT_URI,
																ContactsContract.Data._ID + " = " +anni_List.get(v.getId()).getId(),
																null);

														anni_layout.removeViewAt(v.getId());

														anni_List.remove(v.getId());
													}
												})
												.setNegativeButton("ƴϿ", null).show();
											}
										}
								);
								

								// DB 
								String raw_contact_id;
								Cursor cursor = getContentResolver().query(
										ContactsContract.RawContacts.CONTENT_URI,  
										new String[] {ContactsContract.RawContacts._ID},
										ContactsContract.RawContacts.CONTACT_ID+"="+contact_id,
										null,
										null);

								if(cursor.moveToNext()){
									raw_contact_id = cursor.getString(0);
									ContentValues values = new ContentValues();
									values.clear();
									values.put(ContactsContract.Data.RAW_CONTACT_ID,raw_contact_id);
									values.put(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.Event.CONTENT_ITEM_TYPE);
									values.put(ContactsContract.Data.DATA1, date.getYear()+"-"+date.getMonth()+"-"+date.getDay());
									values.put(ContactsContract.Data.DATA2, rb.isChecked()?"3":"1");
									values.put(ContactsContract.Data.DATA14, et.getText().toString());
									values.put(ContactsContract.Data.DATA15, lunar?"1":"0");
									
									Uri uri = getContentResolver().insert(ContactsContract.Data.CONTENT_URI, values);
									
									Toast.makeText(HayModify.this, "Ʒ ߰Ǿϴ.\nġϽø Ͻ  ֽϴ.", 1).show();
									
									date.setId( Integer.parseInt(uri.getLastPathSegment()) );
									
									anni_layout.addView(text);
									anni_List.add(date);
								}
								else{
									Toast.makeText(HayModify.this, "Ͽϴ. α׷  ٽ õغ.", 1).show();
								}
							}
						})
						.setNegativeButton("ڷ", new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int whichButton) {
							}
						})
						.create().show();
					}
				}
		);
	}

	private void save(){
		db.open();

		//߰  Ѵ.
		String twitter = edittext_twitter.getText().toString();
		String me2day = edittext_me2day.getText().toString();
		db.updateAddtion(contact_id, twitter, me2day);
		db.close();
	}

	private void init(){
		String db_twitter="";
		String db_me2day="";

		db.open();
		Cursor cursor_addtion = db.fetchAddtionID(contact_id);

		if(cursor_addtion.moveToNext()){
			db_twitter = cursor_addtion.getString(3);
			db_me2day = cursor_addtion.getString(4);

			edittext_twitter.setText(db_twitter);
			edittext_me2day.setText(db_me2day);
		}
		else{
			db.insertAddtion(contact_id);
		}

		cursor_addtion.close();

		//
		HayAnniversaryAdapter birthday_adapter = new HayAnniversaryAdapter(getContentResolver());
		ArrayList<HayAnniversary> birthdays = birthday_adapter.getBirthdays(contact_id);

		Log.d("mytag", "anniversary2");

		for(int i =0; i<birthdays.size();i++){
			HayAnniversary anniversary = birthdays.get(i);

			Date date = new Date();
			date.setName( ((anniversary.getType()==3)?"  ":"  "));
			date.setYear( anniversary.getYear()+"" );
			date.setMonth( anniversary.getMonth()+"" );
			date.setDay( anniversary.getDay()+"" );
			date.setId( anniversary.getId());

			TextView text = new TextView(this);
			text.setId(anni_List.size());
			text.setText( "["+date.getName()+" "+anniversary.getText()+"] "+(anniversary.isLunar()?" ":" ")+ date.getYear()+" "+date.getMonth()+" "+date.getDay()+"");
			text.setTextColor(Color.BLACK);
			text.setTextSize(12);
			text.setPadding(10,5,0,5);
			text.setOnClickListener(
					new View.OnClickListener() {
						public void onClick(final View v) {
							new AlertDialog.Builder(HayModify.this)
							.setTitle("Ͻðڽϱ?")
							.setMessage(((TextView)v).getText())
							.setIcon(R.drawable.icon)
							.setPositiveButton("",
									new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int which) {

									//Ŭÿ 
									getContentResolver().delete(
											ContactsContract.Data.CONTENT_URI,
											ContactsContract.Data._ID + " = " +anni_List.get(v.getId()).getId(),
											null);

									anni_layout.removeViewAt(v.getId());

									anni_List.remove(v.getId());


								}
							})
							.setNegativeButton("ƴϿ", null).show();
						}
					}
			);

			anni_layout.addView(text);

			anni_List.add(date);	
		}

		db.close();
	}

	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if(keyCode==4){
			AlertDialog.Builder ab = new AlertDialog.Builder(this);
			ab.setTitle("Ͻðڽϱ?");
			ab.setIcon(R.drawable.icon);
			ab.setPositiveButton("ϱ",
					new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int which) {
					save();
					finish();
				}});
			ab.setNegativeButton("ڷΰ", 					
					new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int which) {
					finish();
				}});
			ab.create().show();
		}
		return false;
	}


	private class Date {

		private String name;
		private String year;
		private String month;
		private String day;
		private int id;


		public int getId() {
			return id;
		}
		public void setId(int id) {
			this.id = id;
		}
		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
		public String getYear() {
			return year;
		}
		public void setYear(String year) {
			this.year = year;
		}
		public String getMonth() {
			return month;
		}
		public void setMonth(String month) {
			this.month = month;
		}
		public String getDay() {
			return day;
		}
		public void setDay(String day) {
			this.day = day;
		}
	}
}
